module jp.ku6.tetris.winmain;

import core.runtime;
import core.thread;
import std.stream;
import std.math;
import jp.ku6.windows.win32api.windows;
import jp.ku6.windows.win32api.winuser;
import jp.ku6.windows.game.application;
import jp.ku6.windows.game.graphics;
import jp.ku6.windows.game.input;
import jp.ku6.windows.game.audio;
import jp.ku6.tetris.game;

//--------------------------------------------------------------
// D言語でWindowsアプリを作るときの基本処理

extern (Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	if (Runtime.initialize() == 0)
		return 1;
	scope(exit) Runtime.terminate();

	Application.startup(hInstance, 960, 540, "Full HD Tetris", "Full HD Tetris", null, null, null);
	scope (exit) Application.shutdown();

	if (Application.instance.isStarted("Full HD Tetris"))
	{
		MessageBoxW(null, "既に起動しています"w.ptr, "Error\0"w.ptr, MB_OK | MB_ICONEXCLAMATION);
		return 2;
	}

	int result;
	try
	{
		Graphics.startup(1920, 1080);
		scope (exit) Graphics.shutdown();

		Input.startup(1920, 1080);
		scope (exit) Input.shutdown();

		Audio.startup();
		scope (exit) Audio.shutdown();

		auto game = new Tetris;
		scope (exit) delete game;

		while (Application.instance().isValid())
		{
			game.mainLoop();
		}
	}
	catch (Throwable o)
	{
		wstring message = std.utf.toUTF16(o.toString() ~ "\0");
		MessageBoxW(null, message.ptr, "Error\0"w.ptr, MB_OK | MB_ICONEXCLAMATION);
		result = 3;
	}

	return result;
}
